//
//  SelectAreaView.m
//  TonyAngRightSelectDemo
//
//  Created by TonyAng on 2017/2/24.
//  Copyright © 2017年 TonyAng. All rights reserved.
//

#import "SelectAreaView.h"
#import <Masonry.h>
@interface SelectAreaView()<UITableViewDataSource,UITableViewDelegate>

@property (nonatomic, strong) NSArray *dataArray;//数据源
@property (nonatomic, strong) UITableView    *tableView;
@property (nonatomic, strong) NSMutableArray *indexArray;//存下标数组
@property (nonatomic, strong) NSMutableArray *sectionArray;//存处理过以后的数组

//@property (nonatomic, strong) NSMutableArray *dataArray;
@property(nonatomic, strong) UIImageView *noGoodsDataImageView;
@property(nonatomic, strong) UILabel *noGoodsDataLabel;

@end

@implementation SelectAreaView

-(instancetype)initWithFrame:(CGRect)frame withParamsDic:(NSDictionary *)params
{
    self = [super initWithFrame:frame];
    self.paramsDic = params;
    if (self) {
        
        _dataArray = [NSArray arrayWithObjects:@"控件", @"感觉",@"iu",@"你吧",@"温柔",@"啊啊",@"骗局",@"门口",@"呃呃",@"快",@"温上",@"急哦",@"mm",@"ush",@"牛",@"2千万",@"&gj",@"#9",@"＊gb",@"228",nil];
        _indexArray = [NSMutableArray array];
        _sectionArray = [NSMutableArray array];
        [self creadeHeadView];
        [self addTableView];
        [self ProcessData];  //整理数据
        
//        [self createGetTicKetTableView];
        //数据
//        [self GetJoyBuy_goodsCarNumData];
        
    }
    return self;
}

#pragma mark -
#pragma mark -------->self.headView
-(void)creadeHeadView{
    self.headView = [UIView  new];
    [self addSubview:self.headView];
    self.headView.backgroundColor = color_default;
    [self.headView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.offset(0);
        make.left.offset(0);
        make.right.offset(0);
        make.height.offset(kFit(40));
    }];
    //标题
    UILabel *time = [[UILabel  alloc] initWithFrame:CGRectMake(0, 0, self.frame.size.width, kFit(40))];
    time.textAlignment = NSTextAlignmentCenter;
    time.font = [UIFont systemFontOfSize:kFit(14)];
    time.textColor = [UIColor whiteColor];
    time.text = @"选择小区";
    [self.headView addSubview:time];
    
    UIButton *closeBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    closeBtn.frame = CGRectMake(self.frame.size.width - kFit(50), 0, kFit(40), kFit(40));
    [closeBtn setTitle:@"关闭" forState:UIControlStateNormal];
    closeBtn.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
    closeBtn.titleLabel.font = [UIFont systemFontOfSize:12];
    [closeBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [closeBtn addTarget:self action:@selector(CloseBtnAction) forControlEvents:UIControlEventTouchUpInside];
    [self.headView addSubview:closeBtn];
}

#pragma mark - 列表
- (void)addTableView{
    _tableView = [[UITableView alloc] initWithFrame:CGRectZero style:UITableViewStylePlain];
    _tableView.delegate = self;
    _tableView.dataSource = self;
    _tableView.tableFooterView= [[UIView alloc] init];
    [self addSubview:_tableView];
    //更改索引的背景颜色:
    self.tableView.sectionIndexBackgroundColor = [UIColor clearColor];
    //更改索引的文字颜色:
    self.tableView.sectionIndexColor = UIColorFromRGB(0x999999);
    [_tableView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.offset(kFit(40));
        make.bottom.offset(0);
        make.left.offset(0);
        make.right.offset(0);
    }];
}

-(void)ProcessData{
    for (int i = 0; i < _dataArray.count; i ++) {
        NSString *str = _dataArray[i]; //一开始的内容
        if (str.length) {  //下面那2个转换的方法一个都不能少
            NSMutableString *ms = [[NSMutableString alloc] initWithString:str];
            //汉字转拼音
            if (CFStringTransform((__bridge CFMutableStringRef)ms, 0, kCFStringTransformMandarinLatin, NO)) {
            }
            //拼音转英文
            if (CFStringTransform((__bridge CFMutableStringRef)ms, 0, kCFStringTransformStripDiacritics, NO)) {
                //字符串截取第一位
                NSString *firstStr = [ms substringToIndex:1];
                //如果不是字母开头的，转为＃
                BOOL isLetter = [self MatchLetter:firstStr];
                if (!isLetter)
                    firstStr = @"#";
                
                //如果还没有索引
                if (_indexArray.count <= 0) {
                    //保存当前这个做索引
                    [_indexArray addObject:firstStr];
                    //用这个字母做字典的key，将当前的标题保存到key对应的数组里面去
                    NSMutableArray *array = [NSMutableArray arrayWithObject:str];
                    NSMutableDictionary *dic = [NSMutableDictionary dictionaryWithObjectsAndKeys:array,firstStr, nil];
                    [_sectionArray addObject:dic];
                }else{
                    //如果索引里面包含了当前这个字母，直接保存数据
                    if ([_indexArray containsObject:firstStr]) {
                        //取索引对应的数组，保存当前标题到数组里面
                        NSMutableArray *array = _sectionArray[0][firstStr];
                        [array addObject:str];
                        //重新保存数据
                        NSMutableDictionary *dic = [NSMutableDictionary dictionaryWithObjectsAndKeys:array,firstStr, nil];
                        [_sectionArray addObject:dic];
                    }else{
                        //如果没有包含，说明是新的索引
                        [_indexArray addObject:firstStr];
                        //用这个字母做字典的key，将当前的标题保存到key对应的数组里面去
                        NSMutableArray *array = [NSMutableArray arrayWithObject:str];
                        NSMutableDictionary *dic = _sectionArray[0];
                        [dic setObject:array forKey:firstStr];
                        [_sectionArray addObject:dic];
                    }
                }
            }
        }
    }
    
    //将字母排序
    NSArray *compareArray = [[_sectionArray[0] allKeys] sortedArrayUsingSelector:@selector(compare:)];
    _indexArray = [NSMutableArray arrayWithArray:compareArray];
    
    //判断第一个是不是字母，如果不是放到最后一个
    BOOL isLetter = [self MatchLetter:_indexArray[0]];
    if (!isLetter) {
        //获取数组的第一个元素
        NSString *firstStr = [_indexArray firstObject];
        //移除第一项元素
        [_indexArray removeObjectAtIndex:0];
        //插入到最后一个位置
        [_indexArray insertObject:firstStr atIndex:_indexArray.count];
    }
    
    [_tableView reloadData];
}

#pragma mark -
#pragma mark 返回有多少分区
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return _indexArray.count;
}

#pragma mark -
#pragma mark 返回一个分区有多少行
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [_sectionArray[0][_indexArray[section]] count];
}
#pragma mark -
#pragma mark 返回某个分区的单元格的高度
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return kFit(40);
}

#pragma mark -
#pragma mark 返回表的单元格对象
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *identifer = @"identifer";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:identifer];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:identifer];
    }
    // 设置单元格附件样式
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    cell.backgroundColor = [UIColor whiteColor];
    NSArray *currentArray = _sectionArray[0][_indexArray[indexPath.section]];
    cell.textLabel.text =currentArray[indexPath.row];
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [tableView deselectRowAtIndexPath:indexPath animated:NO];
    if (self.selectAreaBlock) {
        NSArray *currentArray = _sectionArray[0][_indexArray[indexPath.section]];
        self.selectAreaBlock(currentArray[indexPath.row]);
    }
}


//设置右侧索引的标题，这里返回的是一个数组哦！
- (nullable NSArray<NSString *> *)sectionIndexTitlesForTableView:(UITableView *)tableView
{
    NSMutableArray *tempArray = [NSMutableArray array];
    for (NSString *tempStr in _indexArray) {
      [tempArray addObject:[tempStr uppercaseString]];
    }
    return tempArray;
}

#pragma mark -
#pragma mark -------->关闭
-(void)CloseBtnAction{
    if (self.closeAreaBlock) {
        self.closeAreaBlock();
    }
}

-(void)setSelectAreaBlock:(void (^)(NSString *))selectAreaBlock{
    _selectAreaBlock = selectAreaBlock;
}

-(void)setCloseAreaBlock:(void (^)())closeAreaBlock{
    _closeAreaBlock = closeAreaBlock;
}

#pragma mark - 匹配是不是字母开头
-(BOOL)MatchLetter:(NSString *)str
{
    //判断是否以字母开头
    NSString *ZIMU = @"^[A-Za-z]+$";
    NSPredicate *regextestA = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", ZIMU];
    
    if ([regextestA evaluateWithObject:str] == YES)
        return YES;
    else
        return NO;
}


#pragma mark -
#pragma mark -------->获取现金抵扣券数据
//-(void)GetJoyBuy_goodsCarNumData{
//    
//    self.dataArray = [NSMutableArray array];
//    NSLog(@"获取现金抵扣券数据params--------->%@",self.paramsDic);
//    NSString *tempStrURL = [NSString stringWithFormat:@"%@%@",BASE_JoyBuy_BASEURL,API_JoyBuy_cartCoupon];
//    NSLog(@"获取现金抵扣券数据tempStrURL---->%@",tempStrURL);
//    [HDNetworkHelper POST:tempStrURL parameters:self.paramsDic success:^(id responseObject) {
//        NSLog(@"获取现金抵扣券数据responseObject------->%@",responseObject);
//        _getTicketModel = [[GetTicketModel alloc] initWithDictionary:responseObject error:nil];
//        if (self.dataArray.count > 0) {
//            [self.dataArray removeAllObjects];
//        }
//        for (GetTicketCartCouponListModel *detail_model in _getTicketModel.cartCouponList) {
//            [self.dataArray addObject:detail_model];
//        }
//        if (self.dataArray.count > 0) {
//            [self.getTicKetTableView reloadData];
//        }else{
//            [self createView];
//        }
//        
//    } failure:^(NSError *error) {
//        NSLog(@"error------->%@",error);
//    }];
//}


/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

/*
 //去掉 UItableview headerview 黏性(sticky)
 - (void)scrollViewDidScroll:(UIScrollView *)scrollView {
 if (scrollView == self.getTicKetTableView)
 {
 CGFloat sectionHeaderHeight = 60; //sectionHeaderHeight
 if (scrollView.contentOffset.y<=sectionHeaderHeight&&scrollView.contentOffset.y>=0) {
 scrollView.contentInset = UIEdgeInsetsMake(-scrollView.contentOffset.y, 0, 0, 0);
 } else if (scrollView.contentOffset.y>=sectionHeaderHeight) {
 scrollView.contentInset = UIEdgeInsetsMake(-sectionHeaderHeight, 0, 0, 0);
 }
 }
 }
 */

@end
